<script setup lang="ts">
import ImportCard from "@/components/organisms/card/vertical-card/ImportCard.vue";
import RepositoryCard from "@/components/organisms/card/vertical-card/entity-card/RepositoryCard.vue";
import {onMounted} from "vue";
import {useRepositoryListStore} from "@/stores/Repository/RepositoryListStore";
import MainTemplate from "@/components/templates/MainTemplate.vue";
import RowList from "@/components/organisms/list/RowList.vue";
import {useRepositoryImportModalStore} from "@/stores/Repository/RepositoryImportModalStore";
import RepositoryImportModal
  from "@/components/organisms/modal/Repository/RepositoryImportModal/RepositoryImportModal.vue";
import {RepositoryApiHandler} from "@/handlers/RepositoryApiHandler";
import type Repository from "@/entities/Repository/Repository";
import NewVersionModal from "@/components/organisms/modal/Repository/NewVersionModal/NewVersionModal.vue";

const repositoryList = useRepositoryListStore();
const repositoryImportModalStore = useRepositoryImportModalStore();

const repositoryHandler = new RepositoryApiHandler();

onMounted(() => {
  repositoryHandler
      .list()
      .then((repositories: Array<Repository>) => repositoryList.initRepositoryList(repositories))
})
</script>

<template>
  <MainTemplate>
    <RowList>
      <ImportCard @click="repositoryImportModalStore.show"/>
      <RepositoryCard :repository=repo :key="'repository_' + repo.code" v-for="(repo) of repositoryList.repositories"/>
    </RowList>
  </MainTemplate>
  <NewVersionModal/>
  <RepositoryImportModal/>
</template>
